groovy.transform.stc

## Annotation Type ClosureParams

    @Target(value=PARAMETER)
     @Retention(value=RUNTIME)
    public @interface ClosureParams

Parameter annotation aimed at helping the IDEs or the static type checker to infer the parameter types of a closure. Without this annotation, a method signature may look like this:

`public <T,R> List<R> doSomething(List<T> source, Closure<R> consumer)`

The problem this annotation tries to solve is to define the expected parameter types of the consumer closure. The generics type defined in `Closure<R>` correspond to the result type of the closure, but tell nothing about what the closure must accept as arguments.

There's no way in Java or Groovy to express the type signature of the expected closure call method from outside the closure itself, so we rely on an annotation here. Unfortunately, annotations also have limitations (like not being able to use generics placeholder as annotation values) that prevent us from expressing the type directly.

Additionally, closures are polymorphic. This means that a single closure can be used with different, valid, parameter signatures. A typical use case can be found when a closure accepts either a `Map.Entry` or a (key,value) pair, like the `DefaultGroovyMethods.each(java.util.Map, groovy.lang.Closure)` method.

For those reasons, the `ClosureParams` annotation only takes two arguments:

- `value()` defines a `ClosureSignatureHint` hint class that the compiler will use to infer the parameter types
- `options()`, a set of options that are passed to the hint when the type is inferred

As a result, the previous signature can be written like this:

`public <T,R> List<R> doSomething(List<T> source, @ClosureParams(FirstParam.FirstGenericType.class) Closure<R> consumer)`

Which uses the `FirstParam.FirstGenericType` first generic type of the first argument

hint to tell that the only expected argument type corresponds to the type of the first generic argument type of the first method parameter.

Author:
  Cédric Champeau

### Required Element Summary

Required Elements
`java.lang.Class<? extends ClosureSignatureHint>` `value`

### Optional Element Summary

Optional Elements
`java.lang.String[]` `options`

### Element Detail

#### value

    public abstract java.lang.Class<? extends ClosureSignatureHint> value

#### options

    public abstract java.lang.String[] options

Default:
  {}